package com.middlemind.Eds3;

import java.net.DatagramPacket;


/**
 *
 * @author Victor G. Brusca, Middlemind Games
 */
public class RunClientWriteCallBack implements Runnable {

    private Eds3Client cli = null;
    private DatagramPacket sendPacket = null;
    
    public RunClientWriteCallBack(DatagramPacket packet, Eds3Client client) {
        cli = client;
        sendPacket = packet;
    }
    
    @Override
    public void run() {
        try {
            cli.NetworkWriteCallBack(sendPacket);
        } catch(Exception e) {
            if (this.cli != null && !this.cli.IsShuttingDown()) {
                this.cli.wr("Globel exception encountered " + this.cli.GetGlobalErrorCount() + " found out of " + Eds3Client.MAX_GLOBAL_ERRORS);
                this.cli.SetGlobalErrorCount(this.cli.GetGlobalErrorCount() + 1);
                if (this.cli.GetGlobalErrorCount() > Eds3Client.MAX_GLOBAL_ERRORS) {
                    this.cli.Stop();
                }
                
                this.cli.wr(e.getMessage());
                this.cli.PrintStackTrace(e.getStackTrace());
            }         
        }
    }     
}
