package com.middlemind.Eds3;

import com.middlemind.Eds3.unity.GameObjectWrapper;
import java.util.ArrayList;
import java.util.Hashtable;

/**
 *
 * @author Victor G. Brusca, Middlemind Games
 */
public class Utils {

    public static float ZERO = 0.0001f;
    public static boolean LOGGING_ON = true;
    public static boolean VERBOSE = false;
    public static HandleDebugOut HANDLE_DEBUG_OUT = null;

    public static void wr(String s) {
        if(s == null) {
            s = "";
        }
            
        if (LOGGING_ON) {
            if (HANDLE_DEBUG_OUT != null) {
                HANDLE_DEBUG_OUT.wr(s);
            } else {
                System.out.println(s);
                System.out.flush();
            }
        }
    }

    public static String PadRight(String s, int n) {
        String ret = s;
        for(int i = 0; i < n; i++)  {
            ret = ret + " ";
        }        
        return ret;
    }

    public static String PadLeft(String s, int n) {
        String ret = s;
        for(int i = 0; i < n; i++)  {
            ret = " " + ret;
        }        
        return ret;
    }    
    
    public static double SqrDist(GameObjectWrapper p1, Player p2) {
        double deltaX = p1.GetX() - p2.x;
        double deltaY = p1.GetY() - p2.y;
        double deltaZ = p1.GetZ() - p2.z;
        return (double) (deltaX * deltaX + deltaY * deltaY + deltaZ * deltaZ);        
    }
    
    public static double SqrDist(double x, double y, double z, Player p2) {
        double deltaX = x - p2.x;
        double deltaY = y - p2.y;
        double deltaZ = z - p2.z;
        return (double) (deltaX * deltaX + deltaY * deltaY + deltaZ * deltaZ);
    }      
    
    public static double Dist(GameObjectWrapper p1, Player p2) {
        double deltaX = p1.GetX() - p2.x;
        double deltaY = p1.GetY() - p2.y;
        double deltaZ = p1.GetZ() - p2.z;
        return Math.sqrt((double) (deltaX * deltaX + deltaY * deltaY + deltaZ * deltaZ));
    }
    
    public static double Dist(double x, double y, double z, Player p2) {
        double deltaX = x - p2.x;
        double deltaY = y - p2.y;
        double deltaZ = z - p2.z;
        return Math.sqrt((double) (deltaX * deltaX + deltaY * deltaY + deltaZ * deltaZ));
    }    
    
    public static byte[] PeelByteArray(byte[] b, int start, int len) {
        byte[] nb = new byte[len];
        System.arraycopy(b, start, nb, 0, len);
        return nb;
    }

    public static int[] GetOffsets(byte[][] p) {
        int[] ret = new int[p.length + 1];
        int off = 0;
        int len = p.length;

        for (int i = 0; i < len; i++) {
            ret[i] = off;
            off += p[i].length;
        }
        ret[ret.length - 1] = off;
        return ret;
    }

    public static int[] GetLengths(byte[][] p) {
        int[] ret = new int[p.length];
        int len = p.length;

        for (int i = 0; i < len; i++) {
            ret[i] = p[i].length;
        }

        return ret;
    }

    public static int GetRandomIndex(ArrayList list) {
        int len = list.size();
        return (int) (Math.random() * (len - 1));
    }

    public static int GetRandomKey(Hashtable ht) {
        return (int) ht.keySet().toArray()[(int) (Math.random() * ht.keySet().size())];
    }
}
