package com.middlemind.Eds3.unity;

import com.middlemind.Eds3.HandleGameObjectWrapperSerialization;
import java.util.Hashtable;

/**
 *
 * @author Victor G. Brusca, Middlemind Games
 */
public interface GameObjectManager {    
    public Hashtable<Integer, GameObjectWrapper> GetGameObjects();
    public Hashtable<Integer, GameObjectWrapper> GetNetworkGameObjects();
    public Hashtable<Integer, GameObjectWrapper> GetInNetworkGameObjects();
    public Hashtable<String, Integer> GetNameToGameObjectId();
    
    public GameObjectWrapper GetPlayerChar();
    public void SetPlayerChar(GameObjectWrapper pc);
    
    public HandleGameObjectWrapperSerialization GetSerializationHandler();
    public void SetSerializationHandler(HandleGameObjectWrapperSerialization SerH);
    public void RegisterGameObjectName(String name, int id);
    public void AddGameObject(GameObjectWrapper obj, boolean isNetwork);
    public void AddInNetworkGameObject(GameObjectWrapper obj);
    
    public byte[] SerializeNetworkGameObjects();
    public byte[] SerializeGameObjects();
    public void DeserializeNetworkGameObjects(byte[] bIn);
    public void DeserializeGameObjects(byte[] bIn);
    
    public boolean NetworkGameObjectsEquals(GameObjectManager gom);
    public boolean GameObjectsEquals(GameObjectManager gom);
}
